package com.sun.org.apache.xalan.internal.lib;

import org.w3c.dom.NodeList;
import com.sun.org.apache.xml.internal.dtm.ref.DTMNodeProxy;
import org.w3c.dom.Node;

public abstract class ExsltBase
{
    public ExsltBase() {
    }
    
    protected static String toString(Node n) {
        if ((n instanceof DTMNodeProxy)) {
            return ((DTMNodeProxy)n).getStringValue();
        }
        String value = n.getNodeValue();
        if (value == null) {
            NodeList nodelist = n.getChildNodes();
            StringBuffer buf = new StringBuffer();
            for (int i = 0; i < nodelist.getLength(); ++i) {
                Node childNode = nodelist.item(i);
                buf.append(toString(childNode));
            }
            return buf.toString();
        }
        return value;
    }
    
    protected static double toNumber(Node n) {
        double d = 0.0;
        String str = toString(n);
        try {
            d = (double)Double.valueOf(str);
        }
        catch (NumberFormatException e) {
            d = Double.NaN;
        }
        return d;
    }
}
